"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.help = exports.setup = void 0;
var yargs_1 = __importDefault(require("yargs"));
var defaults = {
    style: 'line',
    fileContentToggle: true,
    synchronisedScroll: true,
    highlightCode: true,
    summary: 'closed',
    diffStyle: 'word',
    matching: 'none',
    matchWordsThreshold: 0.25,
    matchingMaxComparisons: 1000,
    renderNothingWhenEmpty: false,
    maxLineSizeInBlockForComparison: 200,
    maxLineLengthHighlight: 10000,
    format: 'html',
    input: 'command',
    output: 'preview',
    ignore: [],
    diffy: undefined,
    file: undefined,
    htmlWrapperTemplate: undefined,
    title: undefined,
    extraArguments: [],
};
var choices = {
    style: ['line', 'side'],
    summary: ['closed', 'open', 'hidden'],
    diffStyle: ['word', 'char'],
    matching: ['lines', 'words', 'none'],
    format: ['html', 'json'],
    input: ['file', 'command', 'stdin'],
    output: ['preview', 'stdout'],
    diffy: ['browser', 'pbcopy', 'print'],
};
function setup() {
    return __awaiter(this, void 0, void 0, function () {
        var currentYear, argv;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    currentYear = new Date().getFullYear();
                    return [4, yargs_1.default
                            .usage('Usage: diff2html [options] -- [diff args]')
                            .option('style', {
                            alias: 's',
                            describe: 'Output style',
                            nargs: 1,
                            choices: choices.style,
                            default: defaults.style,
                        })
                            .option('fileContentToggle', {
                            alias: 'fct',
                            describe: 'Show viewed checkbox to toggle file content',
                            type: 'boolean',
                            default: defaults.fileContentToggle,
                        })
                            .option('synchronisedScroll', {
                            alias: 'sc',
                            describe: 'Synchronised horizontal scroll',
                            type: 'boolean',
                            default: defaults.synchronisedScroll,
                        })
                            .option('highlightCode', {
                            alias: 'hc',
                            describe: 'Highlight Code',
                            type: 'boolean',
                            default: defaults.highlightCode,
                        })
                            .option('summary', {
                            alias: 'su',
                            describe: 'Show files summary',
                            choices: choices.summary,
                            default: defaults.summary,
                        })
                            .option('diffStyle', {
                            alias: 'd',
                            describe: 'Diff style',
                            nargs: 1,
                            choices: choices.diffStyle,
                            default: defaults.diffStyle,
                        })
                            .option('matching', {
                            alias: 'lm',
                            describe: 'Diff line matching type',
                            nargs: 1,
                            choices: choices.matching,
                            default: defaults.matching,
                        })
                            .option('matchWordsThreshold', {
                            alias: 'lmt',
                            describe: 'Diff line matching word threshold',
                            nargs: 1,
                            type: 'number',
                            default: defaults.matchWordsThreshold,
                        })
                            .option('matchingMaxComparisons', {
                            alias: 'lmm',
                            describe: 'Diff line matching maximum line comparisons of a block of changes',
                            nargs: 1,
                            type: 'number',
                            default: defaults.matchingMaxComparisons,
                        })
                            .option('diffMaxChanges', {
                            describe: 'Number of changed lines after which a file diff is deemed as too big and not displayed',
                            nargs: 1,
                            type: 'number',
                        })
                            .option('diffMaxLineLength', {
                            describe: 'Number of characters in a diff line after which a file diff is deemed as too big and not displayed',
                            nargs: 1,
                            type: 'number',
                        })
                            .option('renderNothingWhenEmpty', {
                            describe: 'Render nothing if the diff shows no change in its comparison',
                            type: 'boolean',
                            default: defaults.renderNothingWhenEmpty,
                        })
                            .option('maxLineSizeInBlockForComparison', {
                            describe: 'Maximum number of characters of the bigger line in a block to apply comparison',
                            nargs: 1,
                            type: 'number',
                            default: defaults.maxLineSizeInBlockForComparison,
                        })
                            .option('maxLineLengthHighlight', {
                            describe: 'Maximum number of characters in a line to apply highlight',
                            nargs: 1,
                            type: 'number',
                            default: defaults.maxLineLengthHighlight,
                        })
                            .option('format', {
                            alias: 'f',
                            describe: 'Output format',
                            nargs: 1,
                            choices: choices.format,
                            default: defaults.format,
                        })
                            .option('input', {
                            alias: 'i',
                            describe: 'Diff input source',
                            nargs: 1,
                            choices: choices.input,
                            default: defaults.input,
                        })
                            .option('output', {
                            alias: 'o',
                            describe: 'Output destination',
                            nargs: 1,
                            choices: choices.output,
                            default: defaults.output,
                        })
                            .option('diffy', {
                            alias: 'u',
                            describe: 'Upload to diffy.org',
                            nargs: 1,
                            choices: choices.diffy,
                            default: defaults.diffy,
                        })
                            .option('file', {
                            alias: 'F',
                            describe: 'Send output to file (overrides output option)',
                            nargs: 1,
                            type: 'string',
                            default: defaults.file,
                        })
                            .option('htmlWrapperTemplate', {
                            alias: 'hwt',
                            describe: 'Use a custom template when generating markup',
                            nargs: 1,
                            type: 'string',
                            default: defaults.htmlWrapperTemplate,
                        })
                            .option('title', {
                            alias: 't',
                            describe: 'Page title for HTML output',
                            nargs: 1,
                            type: 'string',
                            default: defaults.title,
                        })
                            .option('ignore', {
                            alias: 'ig',
                            describe: 'ignore a file',
                            type: 'array',
                            default: defaults.ignore,
                        })
                            .example('diff2html -s line -f html -d word -i command -o preview -- -M HEAD~1', 'diff last commit, line by line, word comparison between lines,' +
                            'previewed in the browser and input from git diff command')
                            .example('diff2html -i file -- my-file-diff.diff', 'reading the input from a file')
                            .example('diff2html -f json -o stdout -- -M HEAD~1', 'print json format to stdout')
                            .example('diff2html -F my-pretty-diff.html -- -M HEAD~1', 'print to file')
                            .example('diff2html --ig package-lock.json yarn.lock', 'ignore two particular files when generating the diff')
                            .help()
                            .alias('help', 'h')
                            .alias('help', '?')
                            .version()
                            .alias('version', 'v')
                            .epilog("\u00A9 2014-".concat(currentYear, " rtfpessoa\n      For more information, check out https://diff2html.xyz/\n      For support, check out https://github.com/rtfpessoa/diff2html-cli"))
                            .strict(true)
                            .recommendCommands().argv];
                case 1:
                    argv = _a.sent();
                    return [2, __assign(__assign({}, argv), { ignore: argv.ignore || [], extraArguments: argv._.map(function (e) { return e.toString(); }) })];
            }
        });
    });
}
exports.setup = setup;
function help() {
    yargs_1.default.showHelp('log');
}
exports.help = help;
//# sourceMappingURL=yargs.js.map